## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           python-numba
Version:        0.61.2
Release:        %autorelease
Summary:        Compiling Python code using LLVM

License:        BSD-2-Clause AND MIT AND BSD-3-Clause AND 0-BSD
URL:            https://numba.pydata.org
# Original source at https://github.com/numba/numba/archive/v%{version}/numba-%{version}.tar.gz
# Cuda specific files need to be removed due to licensing
Source:         numba-%{version}.tar.gz

BuildRequires:  python3-devel
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  tbb-devel
# Tests
BuildRequires:  gdb
BuildRequires:  python3-ipython
BuildRequires:  python3-cffi
BuildRequires:  python3-ipykernel
BuildRequires:  python3-jinja2
BuildRequires:  python3-pexpect
BuildRequires:  python3-pip
BuildRequires:  python3-pygments
BuildRequires:  python3-pytest
BuildRequires:  python3-pyyaml
BuildRequires:  python3-scipy

Requires:       gdb
Requires:       graphviz
Requires:       graphviz-python3
Requires:       radare2


# Fill in the actual package description to submit package to Fedora
%global _description %{expand:

Numba is an open source, NumPy-aware optimizing compiler for Python sponsored by Anaconda, Inc. It
uses the LLVM compiler project to generate machine code from Python syntax.

Numba can compile a large subset of numerically-focused Python, including many NumPy functions. Additionally,
Numba has support for automatic parallelization of loops, generation of GPU-accelerated code, and creation of
ufuncs and C callbacks.

For more information about Numba, see the Numba homepage: https://numba.pydata.org and the online documentation:
https://numba.readthedocs.io/en/stable/index.html}

%description %_description

%package -n     python3-numba
Summary:        %{summary}

%description -n python3-numba %_description


%prep
%autosetup -p1 -n numba-%{version}
# Ensure requirements can be met
sed -i 's/min_numpy_build_version = "2.0.0rc1"/min_numpy_build_version = "2.0.1"/g' setup.py
sed -i '/max_numpy_run_version/d' setup.py
# Will tests pass? Maybe raise issue upstream to support wider variety of llvmlite versions
sed -i 's/min_llvmlite_version = "0.44.0dev0"/min_llvmlite_version = "0.43.0"/g' setup.py
sed -i '/setup_requires=build_requires,/d' setup.py
pushd numba
sed -i 's/numpy_version > (2, 1):/numpy_version > (2, 3):/g' __init__.py
sed -i 's/_min_llvmlite_version = (0, 44, 0)/_min_llvmlite_version = (0, 43, 0)/g' __init__.py
popd

%generate_buildrequires
%pyproject_buildrequires


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files -l numba


%check
# This fails, seems missing core-boolean type
#pyproject_check_import


%files -n python3-numba -f %{pyproject_files}
%{_bindir}/numba

%changelog
## START: Generated by rpmautospec
* Sat Dec 28 2024 John Doe <packager@example.com> - 0.61.0rc2-1
- Uncommitted changes
## END: Generated by rpmautospec
